###########################################################
#
#    Copyright (C) 2008 Matt666  and CadFather V1.1
#
#    This program is free software: you can gna gna gna gna... 
#   
###########################################################

module Soften

def self.go(int)
	model = Sketchup.active_model
	sel = model.selection
	case int
		when 1;str = "Soft"
		when 2;str = "Soft entirely"
		when 3;str = "Unsoft all"
	end
	if sel.empty?
		if UI.messagebox(str + " edges on all the drawing? ", MB_YESNO, "Soft 2 face edges")==7
			return nil
		else
			sel = model.active_entities 
		end
	end
	model.start_operation(str +" edges")
	Soften.boucle(sel,int)
	model.commit_operation
end

def self.boucle(ss,int)
	ss.each do |e|
		Soften.boucle(e.entities,int) if e.typename == "Group"
		Soften.boucle(e.definition.entities,int) if e.typename == "ComponentInstance"
		case int	
			when 1
			if e.typename=="Edge" and e.faces.length>1
				if(e.faces[0].normal.angle_between(e.faces[1].normal) < 25.degrees)
					e.soft=true
					e.smooth=true
				end
			end
			
			when 2
			if e.typename=="Edge" and e.faces.length>1
				e.soft=true
				e.smooth=true
			end
			
			when 3
			if e.typename=="Edge"
				e.soft=false
				e.smooth=false
			elsif e.typename=="Face"
				e.edges.each{|edge|edge.soft=false;edge.smooth=false}
			end
			
		end
	end
end

end #module

if (not file_loaded?("Soften.rb"))
	toolbar = UI::Toolbar.new("Soften")
	path = File.dirname(__FILE__) + "/Smooze/"
	
	cmd = UI::Command.new("Soften") { Soften.go 1 }
	cmd.small_icon = path + "Szs16.png"
	cmd.large_icon = path + "Szs24.png"
	cmd.status_bar_text = cmd.tooltip = "Soften Edges"
	toolbar.add_item(cmd)
	
	cmd = UI::Command.new("Soften all") { Soften.go 2 }
	cmd.small_icon = path + "Sz16.png"
	cmd.large_icon = path + "Sz24.png"
	cmd.status_bar_text = cmd.tooltip = "Soften all Edges"
	toolbar.add_item(cmd)

	cmd = UI::Command.new("Unsoften") { Soften.go 3}
	cmd.small_icon = path + "USz16.png"
	cmd.large_icon = path + "USz24.png"
	cmd.status_bar_text = cmd.tooltip = "Unsoften Edges"
	toolbar.add_item(cmd)
	
	toolbar.restore #added MV
end
file_loaded("Soften.rb")
